# This file is part of Androguard.
#
# Copyright (C) 2010, Anthony Desnos <desnos at t0t0.org>
# All rights reserved.
#
# Androguard is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Androguard is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of  
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with Androguard.  If not, see <http://www.gnu.org/licenses/>.

import sys, time, types

VERSION = "ALPHA 0"

class Color:
    normal = "\033[0m"
    black = "\033[30m"
    red = "\033[31m"
    green = "\033[32m"
    yellow = "\033[33m"
    blue = "\033[34m"
    purple = "\033[35m"
    cyan = "\033[36m"
    grey = "\033[37m"
    bold = "\033[1m"
    uline = "\033[4m"
    blink = "\033[5m"
    invert = "\033[7m"

def long2str(l):
   """Convert an integer to a string."""   
   if type(l) not in (types.IntType, types.LongType):   
      raise ValueError, 'the input must be an integer'
                             
   if l < 0:   
      raise ValueError, 'the input must be greater than 0'      
   s = ''   
   while l:         
      s = s + chr(l & 255L)                                                      
      l >>= 8

   return s


def str2long(s):
   """Convert a string to a long integer."""             
   if type(s) not in (types.StringType, types.UnicodeType):
      raise ValueError, 'the input must be a string'
      
   l = 0L   
   for i in s:         
      l <<= 8           
      l |= ord(i)
      
   return l
